<%-- $Id: edit_sample.jsp 5767 2011-09-28 07:31:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Sample"
	import="net.sf.basedb.core.BioSource"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.SAMPLE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Sample sample = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	Item parentType = null;
	String name = null;
	boolean lockEventProperties = false;

	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	boolean readCurrentBioSource = true;
	BioSource currentBioSource = null;
	ItemQuery<Sample> samplesQuery = null;	
	boolean readCurrentBioWell = true;
	BioWell currentBioWell = null;
	boolean lockedWell = false;
	boolean readCurrentBioPlate = true;
	BioPlate currentBioPlate = null;
	
	WellCoordinateFormatter rowFormatter = new WellCoordinateFormatter(true);
	WellCoordinateFormatter columnFormatter = new WellCoordinateFormatter(false);
	
	if (itemId == 0)
	{
		title = "Create sample";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		int bioSourceId = Values.getInt(request.getParameter("biosource_id"));
		int sampleId = Values.getInt(request.getParameter("sample_id"));
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		if (bioSourceId != 0)
		{
			currentBioSource = BioSource.getById(dc, bioSourceId);
			parentType = Item.BIOSOURCE;
			name = currentBioSource.getName() + ".s" + (currentBioSource.countSamples() + 1);
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, currentBioSource, Item.SAMPLE);
			}
		}
		else if (sampleId != 0)
		{
			parentType = Item.SAMPLE;
			Sample s = Sample.getById(dc, sampleId);
			name = s.getName() + ".s" + (s.countSamples()+1);
			samplesQuery = Sample.getQuery();
			samplesQuery.restrict(Restrictions.eq(Hql.property("id"), Expressions.integer(sampleId)));
			if (currentSubtypeId == 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, s, Item.SAMPLE);
			}
		}
		else if (Values.getBoolean(request.getParameter("pooled")))
		{		
			parentType = Item.SAMPLE;
			name = Values.getString(cc.getPropertyValue("name"), "New pooled sample");
			samplesQuery = Sample.getQuery();
			samplesQuery.restrict(Restrictions.in(Hql.property("id"), Expressions.parameter("selected")));
			samplesQuery.setParameter("selected", cc.getSelected(), Type.INT);
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New sample");
		}
		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = (List<ItemSubtype>)cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
		eventDate = (Date)cc.getPropertyObject("creationEvent.eventDate");
	}
	else
	{
		sample = Sample.getById(dc, itemId);
		sample.checkPermission(Permission.WRITE);
		cc.setObject("item", sample);
		title = "Edit sample -- " + HTML.encodeTags(sample.getName());
	
		creationEvent = sample.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		parentType = sample.getParentType();
		name = sample.getName();
		lockEventProperties = !creationEvent.hasPermission(Permission.WRITE);
		
		try
		{
			currentSubtype = sample.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}

		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
	
		try
		{
			if (parentType == Item.BIOSOURCE)
			{
				currentBioSource = (BioSource)sample.getParent();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioSource = false;
		}
		
		try
		{
			currentBioWell = sample.getBioWell();
			lockedWell = sample.isLockedInWell();
			if (currentBioWell != null)
			{
				currentBioPlate = currentBioWell.getPlate();
			}
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioWell = false;
			readCurrentBioPlate = false;
		}
	
		// Query to retrieve parent samples
		if (parentType == Item.SAMPLE)
		{
			samplesQuery = (ItemQuery<Sample>)creationEvent.getSources();
		}
	}
	
	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		ItemSubtype protocolSubtype = currentSubtype == null ? null : currentSubtype.getRelatedSubtype(Item.PROTOCOL);
		if (protocolSubtype == null) protocolSubtype = ItemSubtype.getById(dc, SystemItems.getId(Protocol.SAMPLING));
		defaultProtocols = (List<Protocol>)activeProject.findDefaultItems(dc, protocolSubtype, false);
	}
	
	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<BioSource> recentBioSources = (List<BioSource>)cc.getRecent(dc, Item.BIOSOURCE);
	List<BioPlate> recentBioPlates = (List<BioPlate>)cc.getRecent(dc, Item.BIOPLATE, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), sample);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,linkitems.js,subtypes.js,ajax.js,json2.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Sample" tab
		function validateSample()
		{
			var frm = document.forms['sample'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (Main.trimString(frm.bioplate_id.value) != 0 && Main.trimString(frm.biowell_id.value) == 0)
			{
				alert("You must choose a biowell from the bioplate");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['sample'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.modifiedSamples.value = Link.exportModified(frm, 'S', true).join(',');
				frm.removedSamples.value = Link.getActionIds(-1, 'S').join(',');
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getProtocolId(), ItemSubtype.getSubtypeId('sample'));
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getProtocolId()
		{
			var frm = document.forms['sample'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}
		
		function getParents()
		{
			var frm = document.forms['sample'];
			var parents = new Array();
			if (frm.parentType[0].checked)
			{
				var bioSourceId = Math.abs(parseInt(frm.biosource_id[frm.biosource_id.selectedIndex].value));
				if (bioSourceId > 0) parents[parents.length] = 'BIOSOURCE:'+bioSourceId;
			}
			else
			{
				var ids = Link.getListIds(frm.samples, 'S');
				if (ids.length > 0)
				{
					parents[parents.length] = 'SAMPLE:'+ids.join(':');
				}
			}
			return parents;
		}
		
		function subtypeOnChange()
		{
			var frm = document.forms['sample'];
			var subtypeId = ItemSubtype.getSubtypeId('sample');
			var recentInfo = ItemSubtype.getRecentAndRelatedInfo(subtypeId, 'SAMPLE', ['PROTOCOL', 'BIOPLATE', 'BIOSOURCE', 'SAMPLE']);
			protocolChanged = ItemSubtype.updateSelectionList(frm.protocol_id, recentInfo.PROTOCOL['recent'], recentInfo.PROTOCOL['default']);
			ItemSubtype.updateSelectionList(frm.bioplate_id, recentInfo.BIOPLATE['recent']);
		}
		
		function selectProtocolOnClick()
		{
			var frm = document.forms['sample'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setProtocolCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('sample', 'PROTOCOL', <%=SystemItems.getId(Protocol.SAMPLING)%>);
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}

		function selectBioPlateOnClick()
		{
			var frm = document.forms['sample'];
			var url = '../bioplates/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioPlateCallback';
			if (frm.bioplate_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.bioplate_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:bioPlateType.lockMode=<><%=BioWell.LockMode.LOCKED_AFTER_CREATE.getValue()%>';
			// Restrict to plates that can holds samples
			url += '&tmpfilter:INT:bioPlateType.bioMaterialType=|<%=itemType.getValue()%>';
			var subtypeId = ItemSubtype.getSubtypeId('sample');
			// Restrict to plates with the given subtype
			url += '&tmpfilter:INT:bioPlateType.itemSubtype='+(subtypeId ? '|' + subtypeId : '=');
			url += '&tmpfilter:BOOLEAN:destroyed=false';
			Main.openPopup(url, 'SelectBioplate', 1000, 700);
		}	
		function setBioPlateCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.bioplate_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			frm.biowell_id.remove(1);
			frm.biowell_id.disabled = false;
		}
		function bioPlateOnChange()
		{
			var frm = document.forms['sample'];
			var list = frm.bioplate_id;
			frm.biowell_id.selectedIndex=0;
			frm.biowell_id.remove(1);			
		}

		function initBioWell()
		{
			var frm = document.forms['sample'];
			<%
			if (currentBioWell != null)
			{
				%>
				var list = frm.biowell_id;
				var wellId = <%=currentBioWell.getId()%>;
				Forms.addListOption(list, 1, new Option());
				list[1].value = '<%=currentBioWell.getId()*(sample == null ? 1 : -1)%>';
				list[1].text = '<%=rowFormatter.format(currentBioWell.getRow())%><%=columnFormatter.format(currentBioWell.getColumn())%>';
				list.selectedIndex = 1;
			<%
			}
			%>
		}					
		function selectBioWellOnClick()
		{
			var frm = document.forms['sample'];
			var bioplate_list = frm.bioplate_id;			
			var bioplateId = Math.abs(parseInt(bioplate_list[bioplate_list.selectedIndex].value))
			if (Main.trimString(frm.bioplate_id.value) == 0)
			{
				alert("You must first select the bioplate where the biowell is located");
				return;
			}			
				
			var url = '../bioplates/wells/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioWellCallback';
			if (frm.biowell_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.biowell_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&bioplate_id='+bioplateId;
			url += '&resetTemporary=1&tmpfilter:STRING:$mbm.name='+escape('=');
			url += '&tmpfilter:STRING:originalBioMaterial.name='+escape('=');
			url += '&columns=row,column';
			Main.openPopup(url, 'SelectBiowell', 700, 700);
		}
		function setBioWellCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.biowell_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function parentTypeOnClick()
		{
			var frm = document.forms['sample'];
			var useSamples = frm.parentType[1].checked;
			frm.biosource_id.disabled = useSamples;
			frm.samples.disabled = !useSamples;
			frm.used_quantity.disabled = !useSamples;
			parentsChanged = true;
		}
		function bioSourceOnChange()
		{
			parentsChanged = true;
		}
		function selectBioSourceOnClick()
		{
			var frm = document.forms['sample'];
			var url = '../biosources/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone';
			url += '&callback=setBioSourceCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('sample', 'BIOSOURCE');
			if (frm.biosource_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.biosource_id[1].value));				
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectBioSource', 1000, 700);
		}
		function setBioSourceCallback(id, name)
		{
			var frm = document.forms['sample'];
			var list = frm.biosource_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;

			frm.parentType[0].checked = true;
			frm.parentType[1].checked = false;
			parentTypeOnClick();
			parentsChanged = true;
		}
		
		function addSamplesOnClick()
		{
			var frm = document.forms['sample'];
			var url = 'index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple';
			url += '&callback=addSampleCallback&resetTemporary=1';
			url += ItemSubtype.createRelatedFilter('sample', 'SAMPLE');
			Main.openPopup(url, 'AddSamples', 1000, 700);
		}
		function addSampleCallback(sampleId, name)
		{
			var frm = document.forms['sample'];
			var item = Link.getItem('S', sampleId);
			if (!item) item = new Item('S', sampleId, name+' [-]', '', '');
			Link.addItem(frm.samples, item);
			frm.parentType[0].checked = false;
			frm.parentType[1].checked = true;
			parentTypeOnClick();
			parentsChanged = true;
		}
		function samplesOnChange()
		{
			var frm = document.forms['sample'];
			var item = frm.samples[frm.samples.selectedIndex].item;
			if (item && item.id)
			{
				frm.used_quantity.value = item.value;
				frm.used_quantity.focus();
			}
			else
			{
				frm.used_quantity.value = '';
			}
		}
		function usedQuantityOnBlur()
		{
			var frm = document.forms['sample'];
			var usedQuantity = frm.used_quantity.value;
			var displayQuantity = usedQuantity == '' ? '-' : usedQuantity+' µg';
			for (var i = 0; i < frm.samples.length; i++)	// >
			{
				var option = frm.samples[i];
				if (option.selected && option.item.id)
				{
					option.item.value = usedQuantity;
					var text = option.text.replace(/\[.*\]/, '['+displayQuantity+']');
					option.text = text; 
				}
			}
		}

		function removeOnClick()
		{
			Link.removeSelected(document.forms['sample'].samples);
			parentsChanged = true;
		}

		function init()
		{
			<%
			if (sample == null)
			{
				%>
				var frm = document.forms['sample'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initBioWell();
			initSamples();
			parentTypeOnClick();		
		}
		function initSamples()
		{
			var samples = document.forms['sample'].samples;
			<%
			if (samplesQuery != null)
			{
				samplesQuery.include(Include.ALL);
				samplesQuery.order(Orders.asc(Hql.property("name")));
				ItemResultList<Sample> samples = samplesQuery.list(dc);
				for (Sample s : samples)
				{
					if (sample != null)
					{
						String usedQuantity = Values.formatNumber(creationEvent.getUsedQuantity(s), -1);
						%>
						Link.addNewItem(samples, new Item('S', <%=s.getId()%>, '<%=HTML.javaScriptEncode(s.getName())%> [<%=usedQuantity%> µg]', '<%=usedQuantity%>'));
						<%
					}
					else
					{
						%>
						Link.addItem(samples, new Item('S', <%=s.getId()%>, '<%=HTML.javaScriptEncode(s.getName())%> [-]', '', ''));
						<%
					}
				}
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="sample" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=sample != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Sample" validate="validateSample()" helpid="sample.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					size="40" maxlength="<%=Sample.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>
						onchange="subtypeOnChange()"
						>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">-none-
						<%
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && sample != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><input <%=clazz%> type="text" name="external_id" 
					value="<%=HTML.encodeTags(sample == null ? Values.getString(cc.getPropertyValue("externalId"), "") : sample.getExternalId())%>" 
					size="40" maxlength="<%=Sample.MAX_EXTERNAL_ID_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Original quantity</td>
				<td><input <%=clazz%> type="text" name="original_quantity" 
					value="<%=Values.formatNumber(sample == null ? Values.getFloat(cc.getPropertyValue("originalQuantity"), null): sample.getOriginalQuantity(), -1)%>" size="12" 
					maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
			</tr>
			<tr>
				<td class="prompt">Created</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr>
					<td>
						<input <%=clazz%> type="text" name="event_date" <%=lockEventProperties ? "disabled" : ""%>
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
						&nbsp;
					</td>
					<td>
					<base:button 
						onclick="<%="Dates.selectDate('Created', 'sample', 'event_date', null, '"+jsDateFormat+"')"%>"
						image="calendar.png" 
						title="Calendar&hellip;" 
						tooltip="Select a date from a calendar" 
						disabled="<%=lockEventProperties%>"
					/>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=sample == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
						disabled="<%=lockEventProperties %>"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Bioplate</td>
				<td>
					<base:select 
						id="bioplate_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentBioPlate%>"
						denied="<%=!readCurrentBioPlate%>"
						recent="<%=recentBioPlates%>"
						newitem="<%=sample == null%>"
						onselect="selectBioPlateOnClick()"
						onchange="bioPlateOnChange()"
						disabled="<%=lockedWell%>"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Biowell</td>
				<td>
					<base:select 
						id="biowell_id"
						clazz="selectionlist"
						required="false"						
						current="<%=null %>"
						denied="<%=!readCurrentBioWell%>"
						newitem="<%=sample == null%>"
						onselect="selectBioWellOnClick()"
						onchange="bioWellOnChange()"
						disabled="<%=lockedWell%>"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(sample == null ? cc.getPropertyValue("description") : sample.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'sample', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="parents" title="Parents" helpid="sample.parents" >
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Parent type</td>
				<td>
					<input type="radio" name="parentType" id="parentType.biosource" 
						value="BIOSOURCE" onclick="parentTypeOnClick()"
						<%=parentType != Item.SAMPLE ? "checked" : ""%>
						><label for="parentType.biosource">Biosource</label>
					<input type="radio" name="parentType" id="parentType.sample" 
						value="SAMPLE" onclick="parentTypeOnClick()"
						<%=parentType == Item.SAMPLE ? "checked" : ""%>
						><label for="parentType.sample">Sample</label>
				</td>
			</tr>
			<tr>
				<td class="prompt">Biosource</td>
				<td>
					<base:select 
						id="biosource_id"
						clazz="selectionlist"
						buttonstyle="width: 150px;"
						buttonicon="add.png"
						buttontitle="Select biosource&hellip;"
						buttonclass="leftaligned buttonclass"
						required="false"
						current="<%=currentBioSource%>"
						denied="<%=!readCurrentBioSource%>"
						recent="<%=recentBioSources%>"
						selectrecent="false"
						newitem="<%=sample == null%>"
						onselect="selectBioSourceOnClick()"
						onchange="bioSourceOnChange()"
					/>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Samples</td>
				<td>
					<table border="0" cellspacing="0" cellpadding="0">
					<tr valign="top">
					<td>
						<select name="samples" size="12" multiple class="selectionlist" 
							onchange="samplesOnChange()">
						</select>&nbsp;
						<input type="hidden" name="modifiedSamples" value="">
						<input type="hidden" name="removedSamples" value="">
					</td>
					<td>
						<table border="0" cellspacing="0" cellpadding="0">
						<tr><td style="padding: 1px 0px 4px 0px;"><base:button 
							clazz="leftaligned buttonclass"
							style="width: 150px;"
							onclick="addSamplesOnClick()" 
							title="Add&nbsp;samples&hellip;" 
							tooltip="Add samples"
							/></td></tr>
						<tr><td><base:button 
							clazz="leftaligned buttonclass"
							style="width: 150px;"
							onclick="removeOnClick()" 
							title="Remove" 
							tooltip="Remove the selected samples"
						/></td></tr>
						</table>
					</td>
					</tr>
					</table>
				</td>
			</tr>
			<tr>
				<td class="subprompt">-</td>
				<td>used quantity
				<input <%=clazz%> type="text" name="used_quantity" value=""
							size="12" maxlength="10" onkeypress="return Numbers.numberOnly(event)"
							onkeyup="usedQuantityOnBlur();"
						> (µg)
				</td>
			</tr>					
			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
