<%-- $Id:select_files.jsp 3820 2007-10-12 10:03:18Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.FileStoreEnabled"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.FileSetMember"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.PlatformFileType"
	import="net.sf.basedb.core.UsableDataFileType"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.Subtypable"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="java.util.ArrayList"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final int itemId = Values.getInt(request.getParameter("item_id"));
final int platformId = Values.getInt(request.getParameter("platform_id"), -1);
final int variantId = Values.getInt(request.getParameter("variant_id"), -1);
final int itemSubtypeId = Values.getInt(request.getParameter("itemsubtype_id"), -1);
final ItemContext cc = sc.getCurrentContext(itemType);

final DbControl dc = sc.newDbControl();
try
{

	// Get the current item; null if we are editing a new item
	final FileStoreEnabled item = itemId == 0 ? null : (FileStoreEnabled)itemType.getById(dc, itemId);
	FileSet fileSet = null;
	// Get the current files organized per data file type
	Map<DataFileType, List<FileSetMember>> members = new HashMap<DataFileType, List<FileSetMember>>();
	if (item != null && item.hasFileSet())
	{
		fileSet = item.getFileSet();
		ItemQuery<FileSetMember> query = fileSet.getMembers();
		query.order(Orders.asc(Hql.property("dataFileType.name")));
		query.order(Orders.asc(Hql.property("file.name")));
		List<FileSetMember> all = query.list(dc);
		for (FileSetMember m : all)
		{
			DataFileType dft = m.getDataFileType();
			List<FileSetMember> tmp = members.get(dft);
			if (tmp == null)
			{
				tmp = new ArrayList<FileSetMember>();
				members.put(dft, tmp);
			}
			tmp.add(m);
		}
	}

	// Get the current platform/variant/itemsubtype
	// -- if not submitted in URL use values from current item
	PlatformVariant variant = null;
	Platform platform = null;
	ItemSubtype itemSubtype = null;
	boolean deniedPlatform = false;
	try
	{
		if (itemSubtypeId > 0)
		{
			itemSubtype = ItemSubtype.getById(dc, itemSubtypeId);
		}
		else if (item instanceof Subtypable)
		{
			itemSubtype = ((Subtypable)item).getItemSubtype();
		}
		if (variantId > 0)
		{
			variant = PlatformVariant.getById(dc, variantId);
			platform = variant.getPlatform();
		}
		else if (platformId > 0)
		{
			platform = Platform.getById(dc, platformId);
		}
		else if (item != null)
		{
			variant = item.getVariant();
			platform = item.getPlatform();
		}
	}
	catch (PermissionDeniedException ex)
	{
		deniedPlatform = true;	
	}
	
	// Query to load data file types for specific itemType/platform/variant
	final ItemQuery<DataFileType> fileTypeQuery = 
		Base.getDataFileTypes(itemType, item, platform, variant, itemSubtype);
	List<DataFileType> fileTypes = fileTypeQuery.list(dc);
	String title = "Select data files for " + 
		HTML.encodeTags((item instanceof Nameable ? ((Nameable)item).getName() : 
			(item == null ? " new item" : item.toString())));

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head >
	
	<script language="JavaScript">
	function init()
	{
		if (document.body.addEventListener)
		{
			// Mozilla
			document.body.addEventListener('click', hideVisibleRecentFilesDiv, false);
		}
		else
		{
			// IE.
			document.body.onclick = hideVisibleRecentFilesDiv;
		}
	}
	
	var lastFileTypeId;
	var lastHasValidator = false;
	function addFilesOnClick(fileTypeId, extension, hasValidator)
	{
		var frm = document.forms['datafiles'];
		var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectMultiple&callback=addFileCallback';
		if (extension)
		{
			url += '&resetTemporary=1&tmpfilter:STRING:name='+escape('%.' + extension);
		}
		else
		{
			url += '&resetTemporary=1&filter:STRING:name=';
		}
		lastFileTypeId = fileTypeId;
		lastHasValidator = hasValidator;
		Main.openPopup(url, 'SelectFile', 1000, 700);
	}
	function addFileCallback(fileId, path)
	{
		addFile(lastFileTypeId, fileId, path, lastHasValidator);
	}
	
	function browseOnClick(fileTypeId, extension, hasValidator)
	{
		var frm = document.forms['datafiles'];
		var url = '../../filemanager/index.jsp?ID=<%=ID%>&cmd=SelectOne&callback=setFileCallback';
		if (extension)
		{
			url += '&resetTemporary=1&tmpfilter:STRING:name='+escape('%.' + extension);
		}
		else
		{
			url += '&resetTemporary=1&filter:STRING:name=';
		}
		lastFileTypeId = fileTypeId;
		lastHasValidator = hasValidator;
		Main.openPopup(url, 'SelectFile', 1000, 700);
	}
	function setFileCallback(fileId, path)
	{
		setFile(lastFileTypeId, fileId, path, lastHasValidator);
	}
	function setFile(fileTypeId, fileId, path, hasValidator)
	{
		var frm = document.forms['datafiles'];
		var fileDiv = document.getElementById('filelist.'+fileTypeId+'.file');
		if (fileId)
		{
			fileDiv.innerHTML = '<div id="filelist.'+fileTypeId+'.'+fileId+'">'+path+'</div>';
		}
		else
		{
			fileDiv.innerHTML = '';
		}
		if (hasValidator) frm['datafiles.validate'].checked = true;
		new FileAction('setfile', fileTypeId, fileId);
	}
	function addFile(fileTypeId, fileId, path, hasValidator)
	{
		var frm = document.forms['datafiles'];
		var fileDiv = document.getElementById('filelist.'+fileTypeId+'.'+fileId);
		if (fileDiv) return;
		
		fileDiv = document.createElement('div');
		fileDiv.id = 'filelist.'+fileTypeId+'.'+fileId;
		var html = path + '&nbsp;<img border=0 class="icon" style="cursor: pointer;" title="Remove this file" ';
		html += ' onclick="removeFileOnClick(event, '+fileTypeId+','+fileId+','+hasValidator+')" src="/trunk/images/remove.png">';
		fileDiv.innerHTML = html; 
		document.getElementById('filelist.'+fileTypeId+'.file').appendChild(fileDiv);
		if (hasValidator) frm['datafiles.validate'].checked = true;
		new FileAction('addfile', fileTypeId, fileId);
	}
	function removeFileOnClick(event, fileTypeId, fileId, hasValidator)
	{
		var frm = document.forms['datafiles'];
		var fileDiv = document.getElementById('filelist.'+fileTypeId+'.'+fileId);
		document.getElementById('filelist.'+fileTypeId+'.file').removeChild(fileDiv);
		if (hasValidator) frm['datafiles.validate'].checked = true;
		new FileAction('removefile', fileTypeId, fileId);
		if (event.stopPropagation)
		{
			event.stopPropagation();
		}
		else
		{
			event.cancelBubble = true;
		}
	}
	
	var fileActions = new Array();
	function FileAction(action, fileTypeId, fileId)
	{
		this.action = action;
		this.fileTypeId = fileTypeId;
		this.fileId = fileId;
		

		for (var i = fileActions.length-1; i >= 0; i--)
		{
			var other = fileActions[i];
			
			var remove = false;
			if (action == 'setfile')
			{
				// Remove all other actions for the given file type
				remove = other.fileTypeId == this.fileTypeId;
			}
			else
			{
				// Remove all other actions for the given file type+file
				remove = other.fileTypeId == this.fileTypeId && other.fileId == this.fileId;
			}
			if (remove)	fileActions.splice(i, 1);
		}

		fileActions[fileActions.length] = this;
	}
	
	function writeFileActionsToForm(toForm)
	{
		var frm = document.forms['datafiles'];
		if (frm['datafiles.validate'])
		{
			Forms.createHidden(toForm, 'datafiles.validate', frm['datafiles.validate'].checked ? 1 : 0);
		}
		for (var i = 0; i < fileActions.length; i++)
		{
			var action = fileActions[i];
			Forms.createHidden(toForm, action.action + '.' + action.fileTypeId, action.fileId);
		}
	}
	
	var visibleRecentFilesDiv = null;
	function recentFilesOnClick(event, fileTypeId)
	{
		var recentDiv = document.getElementById('recentfiles.'+fileTypeId);
		var currentDiv = visibleRecentFilesDiv;
		hideVisibleRecentFilesDiv();
		if (currentDiv == recentDiv) return;
		
		var fileCell = document.getElementById('filelist.'+fileTypeId+'.file');
		var pos = Main.getElementPosition(fileCell, true);
		Main.show('recentfiles.'+fileTypeId);
		
		recentDiv.style.top = (pos.bottom-2) + 'px';
		recentDiv.style.left = (pos.left) + 'px';
		recentDiv.style.width = (pos.width+18) + 'px';

		visibleRecentFilesDiv = recentDiv;
		if (event.stopPropagation)
		{
			event.stopPropagation();
		}
		else
		{
			event.cancelBubble = true;
		}
	}

	function selectRecentFile(fileTypeId, fileId, allowMultiple, hasValidator)
	{
		var path = document.getElementById('recentfile.'+fileTypeId+'.'+fileId).innerHTML;
		if (allowMultiple)
		{
			addFile(fileTypeId, fileId, path, hasValidator);
		}
		else
		{
			setFile(fileTypeId, fileId, path, hasValidator);
		}
	}
	
	function hideVisibleRecentFilesDiv()
	{
		if (visibleRecentFilesDiv)
		{
			visibleRecentFilesDiv.style.display = 'none';
			visibleRecentFilesDiv = null;
		}
	}
	</script>
	<style>
	.filelist {
		overflow: auto; 
		padding: 0px;
		border: 1px solid #cccccc;
		background: #FFFFFF;
	}
	.filelist td {
		border-bottom: 1px dotted #cccccc;
		padding: 1px 2px 1px 2px;
	}
	.filelist .filetype {
		width: 150px;
		font-weight: bold;
		background-color: #f0f0f0;
		border-right: 1px solid #cccccc;
		white-space: nowrap;
	}
	.filelist .file {
		cursor: pointer;
	}
	.filelist .required {
		background: #D0F0FF !important;
	}
	.filelist .fileaction {
		max-width: 18px;
		width: 18px;
		text-align: center;
	}
	.recentfiles {
		position: absolute;
		top: 0px;
		left: 0px;
		border: 1px solid #999999;
		background: #ffffff;
		text-align: left;
	}
	.recentfiles .recentfile {
		padding: 2px;
		background: #f0f0f0;
		border-bottom: 1px dotted #d0d0d0;
	}
	.recentfiles .recentfile:hover {
		cursor: pointer;
		background: #d0d0d0;
		padding: 2px;
	}
	.filelist .member {
		xbackground: #ff0000;
	}
	</style>
	</base:head>
	
	<base:body onload="init()" style="background: #E0E0E0;">

		<div id="filelist" class="filelist" style="height: <%=(int)(scale*320)%>px; width:100%">
		<%
		boolean hasNonPlatformFiles = false;			
		boolean activateCheckBoxes = false;
		boolean validationSupport = false;
		if (fileTypes.size() == 0)
		{
			String what = "";
			if (platform != null)
			{
				what = "'" + HTML.encodeTags(platform.getName()) + "' platform";
			}
			else if (itemSubtype != null)
			{
				what = "'" + HTML.encodeTags(itemSubtype.getName()) + "' subtype";
			}
			%>
			<div class="error">
				The <%=what%> doesn't define any file types for 
				<%=itemType.toString() %> items.
			</div>
			<%
		}
		else if (deniedPlatform)
		{
			%>
			<div class="error">Denied</div>
			<%
		}
		else
		{
			%>
			<table border="0" cellspacing="0" cellpadding="0" width="100%">
			<%
			for (DataFileType dft : fileTypes)
			{
				String dftId = Integer.toString(dft.getId());
				String fullLabel = dft.getName();
				String label = Values.trimString(fullLabel, 25);
				
				UsableDataFileType usable = null;
				if (platform != null) 
				{
					usable = platform.getFileType(dft, variant, false);
					if (usable == null && variant != null)
					{
						// If file type is not registered with a variant, also check if it is inherited from platform
						usable = platform.getFileType(dft, null, false);
					}
				}
				else if (itemSubtype != null)
				{
					usable = itemSubtype.getAssociatedDataFileType(dft, false);
				}
				
				boolean isPartOfPlatform = usable != null;
				boolean isRequired = usable == null ? false : usable.isRequired();
				boolean allowMultiple = usable == null ? false : usable.getAllowMultiple();
				String extension = dft.getExtension();
				boolean hasValidator = dft.hasActiveValidator(dc);
				validationSupport |= hasValidator;
				List<FileSetMember> files = members.get(dft);
				List<File> recentFiles = (List<File>)cc.getRecent(dc, Item.FILE, dft.getExternalId());
				%>
				<tr class="item <%=isRequired ? "required" : "" %>" 
					id="filelist.<%=dftId%>">
					<td class="filetype" valign="top"
						id="filelist.<%=dftId%>.label"
						title="<%=fullLabel == label ? "" : HTML.encodeTags(fullLabel)%>"
						><%=HTML.encodeTags(label)%>
						<%
						if (!isPartOfPlatform && !deniedPlatform)
						{
							hasNonPlatformFiles = true;
							%>
							<base:icon image="warning.gif" 
								tooltip="This file is not part of the platform/subtype" />
							<%
						}
						%>
					</td>
					<td class="file" id="filelist.<%=dftId%>.file" 
						onclick="<%="recentFilesOnClick(event, " + dftId + ")"%>">
						<%
						if (files != null && files.size() > 0)
						{
							for (FileSetMember fm : files)
							{
								File file = fm.getFile();
								%>
								<div id="filelist.<%=dftId%>.<%=file.getId()%>" class="member">
								<%=file.getPath() %>
								<base:icon image="remove.png" visible="<%=allowMultiple %>"
									tooltip="Remove this file"
									onclick="<%="removeFileOnClick(event, " + dftId + "," + file.getId() + "," + hasValidator + ")" %>"
								/>
								</div>
								<%
							}
							%>
							<%
						}
						%>
					</td>
					<td class="fileaction">
						<base:icon image="mini_scroll_down.png" 
							visible="<%=recentFiles.size() >= 0 %>"
							tooltip="Select a recently used file"
							onclick="<%="recentFilesOnClick(event, " + dftId + ")"%>"
						/>
						<div id="recentfiles.<%=dftId%>" style="display: none;" class="recentfiles">
							<div class="recentfile"
								onclick="selectRecentFile(<%=dftId%>, 0, false, <%=hasValidator%>)"
								id="recentfile.<%=dftId%>.0"
								><i>- clear -</i></div>
							<%
							for (File recent : recentFiles)
							{
								%>
								<div class="recentfile"
									onclick="selectRecentFile(<%=dftId%>, <%=recent.getId()%>, <%=allowMultiple ? 1 : 0 %>, <%=hasValidator%>)"
									id="recentfile.<%=dftId%>.<%=recent.getId()%>"
									><%=HTML.encodeTags(recent.getPath().toString())%></div>
								<%
							}
							%>
						</div>
					</td>
					<td class="fileaction">
						<base:icon image="add.png" 
							onclick="<%="addFilesOnClick("+dftId+", '" + HTML.javaScriptEncode(extension) + "', "+ hasValidator + ")"%>"
							visible="<%=allowMultiple %>"
						/>
						<base:icon image="browse.png" 
							onclick="<%="browseOnClick("+dftId+", '" + HTML.javaScriptEncode(extension) + "', "+ hasValidator + ")"%>"
							visible="<%=!allowMultiple%>"
						/>
					</td>
				</tr>
				<%
			}
			%>
			</table>
			<%
		}
		%>
		</div>

			<form name="datafiles">
			<table width="100%">
			<tr>
				<td>
					<%
					if (validationSupport)
					{
						%>
						<span title="Enabled this check box to validate and extract metadata from selected files">
						<label for="validateFiles"><b>Validate files</b></label>
						<input type="checkbox" value="1" name="datafiles.validate" id="validateFiles">
						</span>
						<%
					}
					%>
				</td>
				<td>
					<%
					if (hasNonPlatformFiles)
					{
						if (platform != null)
						{
							%>
							<div align="right">
							<base:icon image="warning.gif" /> 
							= The file type is not part of the <i><%=HTML.encodeTags(platform.getName())%></i> platform
							</div>
							<%
						}
						else if (itemSubtype != null)
						{
							%>
							<div align="right">
							<base:icon image="warning.gif" /> 
							= The file type is not part of the <i><%=HTML.encodeTags(itemSubtype.getName())%></i> subtype
							</div>
							<%
						}
					}
					%>
				</td>
			</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
