<%-- $Id $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.plot.OverviewPlotAction"
	import="net.sf.basedb.clients.web.extensions.plot.PlotGenerator"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.DERIVEDBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");

final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final DerivedBioAssay bioAssay = DerivedBioAssay.getById(dc, itemId);
	
	Job job = null;
	boolean readJob = true;
	PluginDefinition plugin = null;
	boolean readPlugin = true;
	PluginConfiguration configuration = null;
	boolean readConfiguration = true;

	try
	{
		job = bioAssay.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
		readPlugin = false;
		readConfiguration = false;
	}
	if (job != null)
	{
		try
		{
			plugin = job.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readPlugin = false;
		}
		try
		{
			configuration = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readConfiguration = false;
		}
	}
	
	final boolean usePermission = bioAssay.hasPermission(Permission.USE);
	final boolean writePermission = bioAssay.hasPermission(Permission.WRITE);
	final boolean deletePermission = bioAssay.hasPermission(Permission.DELETE);
	final boolean sharePermission = bioAssay.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = bioAssay.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = bioAssay.isRemoved();
	final boolean isUsed = isRemoved && bioAssay.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = bioAssay.isOwner();
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioAssay);
	ExtensionsInvoker toolbarInvoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareBioAssay', 600, 400);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if ((tabId == 'overview' || tabId == 'history') && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function runItemPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function newChildBioAssay()
		{
			Main.viewOrEditItem('<%=ID%>', 'DERIVEDBIOASSAY', 0, true, '&parent_id=<%=itemId%>');
		}
		function newRawBioAssay()
		{
			Main.viewOrEditItem('<%=ID%>', 'RAWBIOASSAY', 0, true, '&bioassay_id=<%=itemId%>');
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Derived bioassays" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssay.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
			<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this bioassay" : "You do not have permission to edit this bioassay"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!bioAssay.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this bioassay" : "You do not have permission to delete this bioassay"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=bioAssay.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this bioassay" : "You do not have permission to restore this bioassay"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this bioassay to other user, groups and projects" : "You do not have permission to share this bioassay"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button
				image="add.png"
				onclick="newChildBioAssay()"
				title="New child bioassay&hellip;"
				tooltip="Create a child bioassay from this bioassay"
				visible="<%=sc.hasPermission(Permission.CREATE, Item.DERIVEDBIOASSAY) && usePermission%>"
			/>
			<tbl:button
				image="add.png"
				onclick="newRawBioAssay()"
				title="New raw bioassay&hellip;"
				tooltip="Create a raw bioassay from this bioassay"
				visible="<%=sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY) && usePermission%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runItemPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runItemPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runItemPlugin('RunPlugin')"
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runItemPlugin('RunAnalysisPlugin')"
				title="Run analysis&hellip;" 
				tooltip="Run an analysis plugin with data from this bioassay"
				visible="<%=pluginCount.containsKey(Plugin.MainType.ANALYZE)%>"
			/>
			<ext:render extensions="<%=toolbarInvoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'derivedbioassay.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(bioAssay)%></i></div>
			<%
			if (isRemoved || bioAssay.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=bioAssay.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			
			<table width="100%">
			<tr valign="top">
			<td width="50%">
				<h4>Bioassay set</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Name</td>
					<td><%=HTML.encodeTags(bioAssay.getName())%></td>
				</tr>
				<tr>
					<td class="prompt">Type</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="itemSubtype" /></td>
				</tr>
				<tr>
					<td class="prompt">Physical bioassay</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="physicalBioAssay" /></td>
				</tr>
				<tr>
					<td class="prompt">Parent bioassay</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="parent" /></td>
				</tr>
				<tr>
					<td class="prompt">Extract</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="extract" /></td>
				</tr>
				<tr>
					<td class="prompt">Protocol</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="protocol" /></td>
				</tr>
				<tr>
					<td class="prompt">Hardware</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="hardware" /></td>
				</tr>
				<tr>
					<td class="prompt">Software</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="software" /></td>
				</tr>
				<tr>
					<td class="prompt">Owner</td>
					<td><base:propertyvalue item="<%=bioAssay%>" property="owner" /></td>
				</tr>
				<tr>
					<td class="prompt">Description</td>
					<td><%=HTML.niceFormat(bioAssay.getDescription())%></td>
				</tr>
				</table>
			</td>
			<td width="50%">
				<h4>Job &amp; Plug-in parameters</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Job</td>
					<td><%=Base.getLinkedName(ID, job, !readJob, false)%></td>
				</tr>
				<tr>
					<td class="prompt">Plugin</td>
					<td><%=Base.getLinkedName(ID, plugin, 
							!readPlugin, plugin != null && plugin.hasPermission(Permission.WRITE))%></td>
				</tr>
				<tr>
					<td class="prompt">Plugin configuration</td>
					<td><%=Base.getLinkedName(ID, configuration, !readConfiguration, 
						configuration != null && configuration.hasPermission(Permission.WRITE))%></td>
				</tr>
				<%
				if (job != null)
				{
					%>
					<tr valign=top>
						<td class="prompt">Started</td>
						<td>
							<%=job == null ? "" : dateTimeFormatter.format(job.getStarted())%>
						</td>
					</tr>
					<tr valign=top>
						<td class="prompt">Ended</td>
						<td>
							<%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%>
						</td>
					</tr>
					<tr valign=top>
						<td class="prompt">Server</td>
						<td>
							<%=HTML.encodeTags(job.getServer())%>
						</td>
					</tr>
					<%
					for (String name : job.getParameterNames())
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = job.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
											item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
						<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
				%>
				</table>

			</td>
			</tr>
			</table>
			
			<%
			ItemQuery<DerivedBioAssay> childQuery = bioAssay.getChildren();
			childQuery.include(Include.ALL);
			childQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<DerivedBioAssay> children = childQuery.list(dc);
			if (children.size() == 0)
			{
				%>
				<h4>Child bioassays</h4>
				This bioassay doesn't have any child bioassays
				(or you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="children"
					title="<%="Child bioassays (" + children.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="children"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="itemSubtype"
						title="Type"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (DerivedBioAssay item : children)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="itemSubtype"><base:propertyvalue item="<%=item%>" property="itemSubtype" /></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>
	
			<%
			ItemQuery<RawBioAssay> rawQuery = bioAssay.getRawBioAssays();
			rawQuery.include(Include.ALL);
			rawQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<RawBioAssay> rawBioAssays = rawQuery.list(dc);
			if (rawBioAssays.size() == 0)
			{
				%>
				<h4>Raw bioassays</h4>
				This bioassay doesn't have any child raw bioassays
				(or you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="children"
					title="<%="Raw bioassays (" + rawBioAssays.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="rawBioAssays"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="platform"
						title="Platform"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (RawBioAssay item : rawBioAssays)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="platform"><base:propertyvalue item="<%=item%>" property="platform" /></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>
			
			<jsp:include page="../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
			
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this bioassay" />
			</jsp:include>
			</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations &amp; parameters" 
				tooltip="View annotation values and protocol parameters">
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
				
			</t:tab>
			
			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<%
				if ("overview".equals(tab))
				{
					%>
					<jsp:include page="../../common/overview/overview.jsp">
						<jsp:param name="item_type" value="<%=itemType.name()%>" />
						<jsp:param name="item_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
