<%-- $Id: view_bioassayset.jsp 5610 2011-04-15 13:01:15Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.Transformation"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ParameterInfo"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.plot.OverviewPlotAction"
	import="net.sf.basedb.clients.web.extensions.plot.PlotGenerator"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Iterator"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOASSAYSET;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tabId = Values.getString(request.getParameter("tab"), "properties");

final float scale = Base.getScale(sc);
final String root = request.getContextPath();
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, itemId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final int experimentId = experiment.getId();
	final boolean hasDbSpots = bioAssaySet.getNumSpots() > 0;
	Transformation transformation = bioAssaySet.getTransformation();
	RawDataType rawDataType = experiment.getRawDataType();
	
	Job job = null;
	boolean readJob = true;
	PluginDefinition plugin = null;
	boolean readPlugin = true;
	PluginConfiguration configuration = null;
	boolean readConfiguration = true;

	try
	{
		job = transformation.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
		readPlugin = false;
		readConfiguration = false;
	}
	if (job != null)
	{
		try
		{
			plugin = job.getPluginDefinition();
		}
		catch (PermissionDeniedException ex)
		{
			readPlugin = false;
		}
		try
		{
			configuration = job.getPluginConfiguration();
		}
		catch (PermissionDeniedException ex)
		{
			readConfiguration = false;
		}
	}
	
	final boolean createPermission = experiment.hasPermission(Permission.USE);
	final boolean writePermission = bioAssaySet.hasPermission(Permission.WRITE);
	final boolean deletePermission = bioAssaySet.hasPermission(Permission.DELETE);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, bioAssaySet);
	ExtensionsInvoker toolbarInvoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker overviewPlotInvoker = ExtensionsControl.useExtensions(jspContext, 
			"net.sf.basedb.clients.web.bioassayset.overviewplots");
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js,newjoust.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,newjoust.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&experiment_id=<%=experimentId%>&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&experiment_id=<%=experimentId%>&item_id=<%=itemId%>');
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if (tabId == 'bioassays')
			{
				location.href = '../bioassays/index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>&bioassayset_id=<%=itemId%>&tab='+tabId;
			}
			else if (tabId == 'spotdata')
			{
				location.href = '../spotdata/index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>&bioassayset_id=<%=itemId%>';
			}
			else if ((tabId == 'overviewplots' || tabId == 'cfplots') && tabId != '<%=tabId%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&experiment_id=<%=experimentId%>&bioassayset_id=<%=itemId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function runItemPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&experiment_id=<%=experimentId%>&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}

		function ImageQueue(baseId)
		{
			this.images = new Array();
			this.nextImage = 0;

			this.addImage = function(imageId, url)
			{
				this.images[this.images.length] = imageId;
				var img = document.getElementById(imageId);
				img.realSrc = url;
			}

			this.loadNextImage = function()
			{
				if (this.images.length <= this.nextImage) return;
				var imageId = this.images[this.nextImage];
				var img = document.getElementById(imageId);
				img.src = '../../../images/plot_generating_400x300.gif';
				img.realImg = new Image();
				img.realImg.onload = function()
				{
					img.src = img.realImg.src;
					setTimeout('loadNextImage()', 100);
				};
				img.realImg.src = img.realSrc;
				this.nextImage++;
			}
		}
		
		var plotQueue = new Array();
		var currentQueue = null;
		function registerImage(baseId, plotId, url)
		{
			if (!currentQueue) currentQueue = baseId;
			var imageQueue = plotQueue[baseId];
			if (!imageQueue)
			{
				imageQueue = new ImageQueue(baseId);
				plotQueue[baseId] = imageQueue;
			}
			var imageId = baseId + '.' + plotId;
			imageQueue.addImage(imageId, url);
		}
		function switchOverview(tabControlId, tabId)
		{
			currentQueue = tabId;
			TabControl.setActiveTab(tabControlId, tabId);
			loadNextImage();
		}
		function loadNextImage()
		{
			var imageQueue = plotQueue[currentQueue];
			if (imageQueue) imageQueue.loadNextImage();
		}
		</script>
		<style>
		.plot {
			border: 1px solid #666666; 
			background-image: url('../../../images/plot_empty_400x300.png');
			margin: 2px;
		}
		</style>
	</base:head>
	<base:body onload="loadNextImage()">
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="index.jsp?ID="+ID+"&experiment_id="+experimentId%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="view" active="<%=tabId%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this bioassay set" : "You do not have permission to edit this bioassay set"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!bioAssaySet.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this bioassay set" : "You do not have permission to delete this bioassay set"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=bioAssaySet.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this bioassay set" : "You do not have permission to restore this bioassay set"%>" 
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runItemPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runItemPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button
				image="plotter.gif"
				onclick="<%="openPlotTool(" + itemId + ")"%>"
				title="Plot tool&hellip;"
				tooltip="A simple tool for generating plots"
				visible="<%=hasDbSpots%>"
			/>
			<tbl:button
				image="explorer.png"
				onclick="<%="openExperimentExplorer(" + itemId + ")"%>"
				title="Experiment explorer"
				tooltip="View the data reporter by reporter"
				visible="<%=hasDbSpots%>"
			/>
			<tbl:button
				disabled="<%=!createPermission%>"
				image="<%=createPermission ? "filter.gif" : "filter_disabled.gif"%>"
				onclick="<%="filter(" + itemId +")"%>"
				title="Filter bioassay set&hellip;"
				tooltip="<%=createPermission ? 
					"Create a new bioassay set by filtering this bioassayset" :
					"You do not have permission analyze this experiment"%>"
				visible="<%=pluginCount.containsKey(Plugin.MainType.ANALYZE)%>"
 			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runItemPlugin('RunPlugin')"
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button 
				disabled="<%=!createPermission%>"
				image="<%=createPermission ? "runplugin.gif" : "runplugin_disabled.gif"%>" 
				onclick="<%="runAnalysisPlugin(" + itemId + ")"%>"
				title="Run analysis&hellip;" 
				tooltip="<%=createPermission ? "Run an analysis plugin" : 
					"You do not have permission to analyze this experiment"%>"
				visible="<%=pluginCount.containsKey(Plugin.MainType.ANALYZE)%>"
			/>
			<ext:render extensions="<%=toolbarInvoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'bioassayset.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(bioAssaySet)%></i></div>
			<%
			if (bioAssaySet.isRemoved())
			{
				%>
				<div class="itemstatus">
					<base:icon image="deleted.gif" 
						visible="<%=bioAssaySet.isRemoved()%>"> This item has been flagged for deletion<br></base:icon>
				</div>
				<%
			}
			%>
			
			<table width="100%">
			<tr valign="top">
			<td width="50%">
				<h4>Bioassay set</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Name</td>
					<td><%=HTML.encodeTags(bioAssaySet.getName())%></td>
				</tr>
				<tr>
					<td class="prompt">Experiment</td>
					<td><%=Base.getLinkedName(ID, experiment, false, writePermission)%>
					(<%=experiment.getRawDataType()%>)</td>
				</tr>
				<tr>
					<td class="prompt">Intensity transformation</td>
					<td><%=bioAssaySet.getIntensityTransform().toString()%></td>
				</tr>
				<tr>
					<td class="prompt">Spots</td>
					<td>db: <%=bioAssaySet.getNumSpots()%>; file: <%=bioAssaySet.getNumFileSpots()%></td>
				</tr>
				<tr>
					<td class="prompt">Reporters</td>
					<td>db: <%=bioAssaySet.getNumReporters()%>; file: <%=bioAssaySet.getNumFileReporters()%></td>
				</tr>
				<tr>
					<td class="prompt">Description</td>
					<td><%=HTML.niceFormat(bioAssaySet.getDescription())%></td>
				</tr>
				</table>
				
				<h4>Transformation &amp; job</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Transformation</td>
					<td><%=Base.getLinkedName(ID, transformation, false, 
							transformation.hasPermission(Permission.WRITE))%></td>
				</tr>
				<tr>
					<td class="prompt">Job</td>
					<td><%=Base.getLinkedName(ID, job, !readJob, false)%></td>
				</tr>
				<tr valign=top>
					<td class="prompt">Started</td>
					<td>
						<%=job == null ? "" : dateTimeFormatter.format(job.getStarted())%>
					</td>
				</tr>
				<tr valign=top>
					<td class="prompt">Ended</td>
					<td>
						<%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%>
					</td>
				</tr>
				<tr valign=top>
					<td class="prompt">Server</td>
					<td>
						<%=job == null ? "" : HTML.encodeTags(job.getServer())%>
					</td>
				</tr>
				<tr>
					<td class="prompt">Description</td>
					<td><%=HTML.niceFormat(transformation.getDescription())%></td>
				</tr>
				</table>
			</td>
			<td width="50%">
				<h4>Plugin &amp; parameters</h4>
				<table class="form" cellspacing=0>
				<tr>
					<td class="prompt">Plugin</td>
					<td><%=Base.getLinkedName(ID, plugin, 
							!readPlugin, plugin != null && plugin.hasPermission(Permission.WRITE))%></td>
				</tr>
				<tr>
					<td class="prompt">Plugin configuration</td>
					<td><%=Base.getLinkedName(ID, configuration, !readConfiguration, 
						configuration != null && configuration.hasPermission(Permission.WRITE))%></td>
				</tr>
				<%
				if (job != null)
				{
					for (String name : job.getParameterNames())
					{
						StringBuilder sb = new StringBuilder();
						String displayValue = "";
						String description = "";
						try
						{
							ParameterInfo pi = job.getParameterInfo(name);
							if (pi.getLabel() != null) name = HTML.encodeTags(pi.getLabel());
							description = HTML.encodeTags(pi.getDescription());
							List<?> values = pi.getValues();
							int i = 0;
							for (Object value : values)
							{
								if (value != null)
								{
									if (i > 0) sb.append(", ");
									i++;
									if (value instanceof BasicItem)
									{
										BasicItem item = (BasicItem)value;
										String itemName = "";
										if (item instanceof File)
										{
											itemName = ((File)item).getPath().toString();
										}
										else if (item instanceof Nameable)
										{
											itemName = ((Nameable)item).getName();
										}
										else
										{
											itemName = item.toString();
										}
										sb.append(Base.getLink(ID, HTML.encodeTags(itemName), 
											item.getType(), item.getId(), item.hasPermission(Permission.WRITE)));
									}
									else if (value instanceof Date)
									{
										sb.append(dateFormatter.format((Date)value));
									}
									else
									{
										sb.append(HTML.encodeTags(value.toString()));
									}
								}
							}
							displayValue = sb.toString();
						}
						catch (Throwable ex)
						{
							displayValue = "<i>ERROR: "+ex.getMessage()+"</i>";
						}
						%>
						<tr>
						<td class="prompt"><span title="<%=description%>"><%=name%></span></td>
							<td>
								<%=displayValue%>
							</td>
						</tr>
						<%
					}
				}
				%>
				</table>

			</td>
			</tr>
			</table>
			
			<jsp:include page="../../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
			
			<jsp:include page="../../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this bioassay set" />
			</jsp:include>
			
			<h4 class="docked">Analysis subtree</h4>
			<jsp:include page="analysis_tree.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="experiment_id" value="<%=experimentId%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
			</jsp:include>
			</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values">
				<div class="boxed">
				<jsp:include page="../../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			
			<t:tab id="bioassays" title="Bioassays" />
			
			<t:tab id="spotdata" title="Spot data" 
				visible="<%=hasDbSpots%>" />
			
			<t:tab id="overviewplots" title="Overview plots" 
				tooltip="Predefined plots for all bioassays in this bioassay set"
				visible="<%=overviewPlotInvoker.getNumExtensions() > 0%>">
				<%
				if ("overviewplots".equals(tabId))
				{
					ActionIterator<OverviewPlotAction> plots = overviewPlotInvoker.iterate();
					StringBuilder script = new StringBuilder();
					%>
					<t:tabcontrol id="overviewplots" switch="switchOverview">
					<% 
					while (plots.hasNext())
					{
						OverviewPlotAction action = plots.next();
						String baseId = plots.getExtension().getId() + "." + action.getId();
						%>
						<t:tab 
							tooltip="<%=action.getDescription() %>"
							title="<%=action.getTitle()%>"
							id="<%=baseId%>"
							>
							<%
							for (PlotGenerator generator : action.getPlotGenerators())
							{
								String plotId = generator.getId();
								script.append("registerImage('").append(baseId).append("','")
										.append(plotId).append("','")
										.append(HTML.javaScriptEncode(generator.getUrl())).append("');\n");
								%><img id="<%=baseId + "." + plotId%>"
									class="plot"
									src="../../../images/transparent_pixel.gif"
									width="<%=generator.getWidth()%>"
									height="<%=generator.getHeight()%>"
									alt="<%=HTML.encodeTags(generator.getTitle())%>"
								>&#8203;&#8203;<%
							}
							%>
						</t:tab>
						<%
					}
					%>
					</t:tabcontrol>
					<script language="JavaScript">
					<%=script%>
					</script>
					<%
				}
				%>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
