<%-- $Id: view_rawbioassay.jsp 5685 2011-08-04 10:58:23Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	buffer="500kb"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.SpotImages"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.RAWBIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final String root = request.getContextPath()+"/";
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getString(request.getParameter("tab"), "properties");
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	RawBioAssay rawBioAssay = RawBioAssay.getById(dc, itemId);
	RawDataType rawDataType = null;
	try
	{
		rawDataType = rawBioAssay.getRawDataType();
	}
	catch (Throwable t)
	{}
	
	Job job = null;
	boolean readJob = true;
	try
	{
		job = rawBioAssay.getJob();
	}
	catch (PermissionDeniedException ex)
	{
		readJob = false;
	}
	final Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final boolean writePermission = rawBioAssay.hasPermission(Permission.WRITE);
	final boolean deletePermission = rawBioAssay.hasPermission(Permission.DELETE);
	final boolean sharePermission = rawBioAssay.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = rawBioAssay.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = rawBioAssay.isRemoved();
	final boolean isUsed = isRemoved && rawBioAssay.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = rawBioAssay.isOwner();
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, rawBioAssay);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareRawBioAssay', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function viewRawData()
		{
			location.href = 'rawdata/index.jsp?ID=<%=ID%>&cmd=List&rawbioassay_id=<%=itemId%>';
		}
		function editSpotImages()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=EditSpotImages&item_id=<%=itemId%>', 'EditSpotImages', 540, 460);
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if ((tabId == 'overview' || tabId == 'history') && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else if (tabId == 'rawdata')
			{
				viewRawData();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Raw bioassays" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(rawBioAssay.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this raw bioassay" : "You do not have permission to edit this raw bioassay"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!rawBioAssay.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this raw bioassay" : "You do not have permission to delete this rawbioassay"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=rawBioAssay.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this raw bioassay" : "You do not have permission to restore this rawbioassay"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this raw bioassay to other user, groups and projects" : "You do not have permission to share this raw bioassay"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				onclick="editSpotImages()"
				image="runplugin.gif" 
				title="Create spot images&hellip;"
				visible="<%=writePermission && rawBioAssay.getNumDbSpots() > 0%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'rawbioassay.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(rawBioAssay)%></i></div>
			<%
			if (rawBioAssay.isRemoved() || rawBioAssay.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=rawBioAssay.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			
			<table width="100%">
			<tr valign="top">
			<td>
			
			<table class="form" cellspacing="0">
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(rawBioAssay.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Registered</td>
				<td><%=dateFormatter.format(rawBioAssay.getEntryDate())%></td>
			</tr>
			<tr>
				<td class="prompt">Platform</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="platform" /></td>
			</tr>
			<tr>
				<td class="prompt">Variant</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="variant" /></td>
			</tr>
			<tr>
				<td class="prompt">Raw data type</td>
				<td><base:catch><%=HTML.encodeTags(rawBioAssay.getRawDataType().getName())%></base:catch></td>
			</tr>
			<tr>
				<td class="prompt">Spots</td>
				<td><%=rawBioAssay.hasData() ? "yes (db: " + rawBioAssay.getNumDbSpots() + 
						"; file: " + rawBioAssay.getNumFileSpots() + ")" : "no"%></td>
			</tr>
			<tr>
				<td class="prompt">Parent bioassay</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="parentBioAssay" /></td>
			</tr>
			<tr>
				<td class="prompt">Parent extract</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="parentExtract" /></td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="protocol" /></td>
			</tr>
			<tr>
				<td class="prompt">Software</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="software" /></td>
			</tr>
			<tr>
				<td class="prompt">Array design</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="arrayDesign" /></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=rawBioAssay%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(rawBioAssay.getDescription())%></td>
			</tr>
			</table>
			
			</td>
			<td>
			
			<%
			if (rawBioAssay.getNumDbSpots() > 0)
			{
				%>
				<h4 style="margin-top: 0px;">Raw data import</h4>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt">Job</td>
					<td><%=Base.getLinkedName(ID, job, !readJob, true)%></td>
				</tr>
				<tr>
					<td class="prompt">Date / time</td>
					<td><%=job == null ? "" : dateTimeFormatter.format(job.getEnded())%></td>
				</tr>
				<tr>
					<td class="prompt">Plugin</td>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="job.pluginDefinition" /></td>
				</tr>
				<tr>
					<td class="prompt">Configuration / file format</td>
					<td><base:propertyvalue item="<%=rawBioAssay%>" property="job.pluginConfiguration" /></td>
				</tr>
				</table>
				<%
			}
			%>
			
			<h4>Spot images</h4>
			<%
			if (!rawBioAssay.hasSpotImages())
			{
				%>
				No spot images has been created for this raw bioassay.
				<%
			}
			else
			{
				SpotImages spi = rawBioAssay.getSpotImages();
				%>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt">X scale</td>
					<td><%=spi.getXScale()%></td>
					<td>&nbsp;&nbsp;</td>
					<td class="prompt">Spot size</td>
					<td><%=spi.getSpotsize()%></td>
				</tr>
				<tr>
					<td class="prompt">Y scale</td>
					<td><%=spi.getYScale()%></td>
					<td>&nbsp;&nbsp;</td>
					<td class="prompt">Gamma correction</td>
					<td><%=spi.getGamma()%></td>
				</tr>
				<tr>
					<td class="prompt">X offset</td>
					<td><%=spi.getXOffset()%></td>
					<td>&nbsp;&nbsp;</td>
					<td class="prompt">Quality</td>
					<td><%=spi.getQuality()%></td>
				</tr>
				<tr>
					<td class="prompt">Y offset</td>
					<td><%=spi.getYOffset()%></td>
				</tr>
				<tr>
					<td class="prompt">Red image file</td>
					<td><base:propertyvalue item="<%=spi%>" property="redImageFile" /></td>
				</tr>
				<tr>
					<td class="prompt">Green image file</td>
					<td><base:propertyvalue item="<%=spi%>" property="greenImageFile" /></td>
				</tr>
				<tr>
					<td class="prompt">Blue image file</td>
					<td><base:propertyvalue item="<%=spi%>" property="blueImageFile" /></td>
				</tr>
				<tr>
					<td class="prompt">Spot images file</td>
					<td><base:propertyvalue item="<%=spi%>" property="spotImagesFile" /></td>
				</tr>
				</table>
				<%
			}
			%>

			</td>
			</tr>
			</table>
			
			<jsp:include page="../../common/datafiles/list_files.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
			
			<%
			Set<String> names = rawBioAssay.getHeaderNames();
			if (names == null || names.size() == 0)
			{
				%>
				<h4>Raw data headers</h4>
				None.
				<%
			}
			else
			{
				%>
				<base:section 
					id="headers"
					title="<%="Raw data headers (" + (names == null ? 0 : names.size()) + ")"%>"
					context="<%=cc%>"
					>
					<table class="form" cellspacing="0">
					<%
					boolean needsTr = true;
					if (names != null)
					{
						for (String name : names)
						{
							%>
							<%=needsTr ? "<tr valign=\"top\">" : "" %>
								<td class="prompt"><%=HTML.encodeTags(name)%></td>
								<td><%=HTML.encodeTags(rawBioAssay.getHeader(name))%></td>
								<td>&nbsp;&nbsp;</td>
							<%=needsTr ? "" : "</tr>"%>
							<%
							needsTr = !needsTr;
						}
						%>
						<%=needsTr ? "" : "</tr>"%>
						<%
					}
					%>
					</table>
				</base:section>
				<%
			}
			%>

			<%
			ItemQuery<Experiment> experimentQuery = rawBioAssay.getExperiments();
			experimentQuery.include(Include.ALL);
			experimentQuery.order(Orders.asc(Hql.property("name")));
			ItemResultList<Experiment> experiments = experimentQuery.list(dc);
			if (experiments.size() == 0)
			{
				%>
				<h4>Experiments</h4>
				This raw bioassay isn't used in any experiments
				(or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section 
					id="experiments"
					title="<%="Experiments (" + experiments.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="experiments"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (Experiment item : experiments)
						{
							%>
							<tbl:row>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=item.isRemoved()%>"
								/><%=Base.getLinkedName(ID, item, false, true)%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this sample" />
			</jsp:include>
			<%
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(rawBioAssay));
			ItemResultIterator<User> users = mp.getUsers().iterate(dc);
			ItemResultIterator<Group> groups = mp.getGroups().iterate(dc);
			ItemResultIterator<Project> projects = mp.getProjects().iterate(dc);
			
			if (users.hasNext() || groups.hasNext() || projects.hasNext())
			{
				%>
				<base:section 
					id="sharedTo" 
					title="Shared to"
					context="<%=cc%>">
				<tbl:table 
					id="itemsSharedTo"
					clazz="itemlist"
					columns="all"
				>
					<tbl:columndef 
						id="itemType"
						title="Item type"
					/>
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef 
						id="permissions"
						title="Permissions"
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						while(projects.hasNext())
						{
							Project project = projects.next();
							Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
							%>			
							<tbl:row>
								<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=project.isRemoved()%>"
								/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						while(groups.hasNext())
						{
							Group group = groups.next();
							Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=group.isRemoved()%>"
								/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%	
						}
						while (users.hasNext())
						{
							User user = users.next();
							Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
							%>
							<tbl:row>							
								<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
								<tbl:cell column="name"><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=user.isRemoved()%>"
								/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
								<tbl:cell column="permissions">
									<%=PermissionUtil.translatePermissionsToString(permissions)%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This raw bioassay is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>
			</div>
			</t:tab>
			
			<t:tab id="annotations" title="Annotations &amp; parameters" 
				tooltip="View annotation values and protocol parameters">
				<div class="boxed">
				<jsp:include page="../../common/annotations/list_annotations.jsp">
					<jsp:param name="item_type" value="<%=itemType.name()%>" />
					<jsp:param name="item_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				</div>
			</t:tab>
			<t:tab id="rawdata" title="Raw data" visible="<%=rawBioAssay.getNumDbSpots() > 0%>" />
			<t:tab id="overview" title="Overview" 
				tooltip="Display a tree overview of related items">
				<%
				if ("overview".equals(tab))
				{
					%>
					<jsp:include page="../../common/overview/overview.jsp">
						<jsp:param name="item_type" value="<%=itemType.name()%>" />
						<jsp:param name="item_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			<t:tab id="history" title="Change history" 
				tooltip="Displays a log of all modifications made to this item"
				visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
				<%
				if ("history".equals(tab))
				{
					%>
					<jsp:include page="../../common/history/frameset.jsp">
						<jsp:param name="source_type" value="<%=itemType.name()%>" />
						<jsp:param name="source_id" value="<%=itemId%>" />
						<jsp:param name="ID" value="<%=ID%>" />
					</jsp:include>
					<%
				}
				%>
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
